'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function () {
    var _this = this;

    this.iterateDirections(function (direction, lengths) {

        var stretchValues = lengths.filter(isStretch).map(stretchValue);
        var totalStretch = addAll(stretchValues);

        if (totalStretch === undefined) {
            if (_this.isAlignedInDirection(direction)) {
                return;
            } else {
                throw new Error('No stretch value found');
            }
        }

        var remainingValues = lengths.filter(function (length) {
            return !isStretch(length);
        });
        var totalRemaining = addAll(remainingValues) || '0';

        lengths.forEach(function (length, i) {
            if (isStretch(length)) {
                lengths[i] = 'calc((99.9% - ' + totalRemaining + ') * ' + stretchValue(length) + ' / ' + totalStretch + ')';
                // (100% - totalRemaining) * thisStretch / totalStretch
            }
        });

        _this.setDirection(direction, lengths);
    });

    return this;
};

// Tell if `length` is a stretch length
var isStretch = exports.isStretch = function isStretch(length) {
    var unit = length.match(/[A-z]+/);
    return unit !== null && unit[0] === 's';
};

// Get the number before the 's' unit
var stretchValue = exports.stretchValue = function stretchValue(length) {
    if (!isStretch(length)) {
        throw new Error(length + ' is not a stretch length');
    }
    return length.slice(0, -1);
};

var addAll = function addAll(array) {
    if (array.length === 0) {
        return undefined;
    } else {
        var str = '(' + array[0];
        return array.slice(1).reduce(function (a, b) {
            return a + ' + ' + b;
        }, str) + ')';
    }
};

// Turn all stretch lengths into valid calc expressions